SystemOrganization addCategory: #'GT-InspectorExtensions-Pillar'!

!PRDocumentItem methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 4/1/2014 07:43'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 40>
	composite text 
		title: 'Text';
		display: [ self text ]! !

GLMHighlighterTextStylerDecorator subclass: #GTPillarHighlighterTextDecorator
	instanceVariableNames: 'presentation fileReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarHighlighterTextDecorator class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/1/2014 15:14'!
inPresentation: aGLMRubricPresentation
	^ self new presentation: aGLMRubricPresentation ! !

!GTPillarHighlighterTextDecorator class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/2/2014 10:13'!
inPresentation: aGLMRubricPresentation fileReference: aFileReference
	^ self new 
		presentation: aGLMRubricPresentation;
		fileReference: aFileReference ! !

!GTPillarHighlighterTextDecorator class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/1/2014 11:55'!
key
	^ self name! !

!GTPillarHighlighterTextDecorator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 9/2/2014 16:49'!
defaultStyler

	^ GLMHighlighterTextParserStyler new
		view: self;
		parser: self

	! !

!GTPillarHighlighterTextDecorator methodsFor: 'accessing' stamp: 'TudorGirba 9/2/2014 10:13'!
fileReference
	^ fileReference! !

!GTPillarHighlighterTextDecorator methodsFor: 'accessing' stamp: 'TudorGirba 9/2/2014 10:13'!
fileReference: anObject
	fileReference := anObject! !

!GTPillarHighlighterTextDecorator methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/2/2014 10:13'!
parse: aString onError: anError
	| result |
	result := aString asText.
	(GTPillarParser new parse: aString) do: [ :each | 
		each 
			executeOn: result 
			inPresentation: self presentation 
			relativeToFileReference: self fileReference ].
	^ result! !

!GTPillarHighlighterTextDecorator methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/1/2014 12:07'!
parser
	^ self! !

!GTPillarHighlighterTextDecorator methodsFor: 'accessing' stamp: 'TudorGirba 9/1/2014 15:14'!
presentation
	^ presentation! !

!GTPillarHighlighterTextDecorator methodsFor: 'accessing' stamp: 'TudorGirba 9/1/2014 15:14'!
presentation: anObject
	presentation := anObject! !

PPCompositeParser subclass: #GTPillarParser
	instanceVariableNames: 'code link codeIsland linkIsland fileLabel filePreamble fileName file headingIsland heading embed embedIsland url urlLabel urlName fileSetting note noteIsland'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/27/2014 06:46'!
code
	"TODO: provide more precise definition of a code rule"
	^ '[[[' asParser, ']]]' asParser negate star flatten token, ']]]' asParser ==> [ :res | 
		GTPillarCodeHighlightingCommand new token: res second ]! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:08'!
codeIsland
	^ code island ==> #second! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 11:28'!
embed
	^ '+' asParser , file token , '+' asParser ==> [:res | 
		GTPillarFileHighlightingCommand new 
			token: res second]! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 11:29'!
embedIsland
	^ embed island ==> #second! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 14:26'!
file
	^ fileLabel optional , filePreamble , fileName , fileSetting star ==> #third! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/2/2014 11:18'!
fileLabel
	^ ($> asParser negate plus flatten , $> asParser) flatten! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 14:28'!
fileName 
	^ ($+ asParser / $| asParser) negate plus flatten! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/22/2014 21:05'!
filePreamble
	^ 'file://' asParser! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 14:27'!
fileSetting
	^ $| asParser , ($+ asParser / $| asParser) negate plus! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 11:15'!
heading
	^ #startOfLine asParser , ($!! asParser , #newline asParser negate star) token ==> [:res | 
		GTHeadingHighlightingCommand new token: res second]! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 11:04'!
headingIsland
	^ heading island ==> #second! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 11:29'!
link
	^ '*' asParser , url token , '*' asParser ==> [:res | 
		GTPillarLinkHighlightingCommand new token: res second]! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:08'!
linkIsland
	^ link island ==> #second! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 16:01'!
note
	^ #startOfLine asParser , ('@@' asParser , #newline asParser negate star) token ==> [:res | 
		GTNoteHighlightingCommand new token: res second]! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 16:00'!
noteIsland
	^ note island ==> #second! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 16:00'!
start
	^ (codeIsland / linkIsland / embedIsland / headingIsland / noteIsland) star! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 11:50'!
url
	^ urlLabel optional , urlName ==> #second! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 15:56'!
urlLabel
	^ (($> asParser / $* asParser) negate plus flatten , $> asParser) flatten! !

!GTPillarParser methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 11:49'!
urlName 
	^ $* asParser negate plus flatten! !

!PRDocumentGroup methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 4/1/2014 07:42'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	composite tree 
		title: 'Tree';
		display: [ { self } ];
		children: [ :each | 
			each hasChildren 
				ifTrue: [each children]
				ifFalse: [ { } ] ];
		when: #hasChildren! !

!PRExportConfiguration methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 4/8/2014 06:52'!
gtInspectorInputFilesIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite list 
		title: 'Files';
		display: [self inputFiles];
		format: #basename! !

PPCompositeParserTest subclass: #GTPillarParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/26/2014 22:05'!
parserClass
	^ GTPillarParser! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:01'!
source1
	^ '
!!Concurrent Programming in Pharo

Let us start with a simple example. We will explain all the details in subsequent sections. The following code creates two processes using the message ==fork== sent to a block. In each process we enumerate numbers. During each loop step, using the expression ==Processor yield==, the current process stop its execution to give a chance to other processes with the same priority to get executed. At the end of the loop we refresh the ==Transcript==.

[[[
[	1 to: 10 do: 
    [:i | Transcript nextPutAll: i  printString, '' ''. Processor yield].
Transcript endEntry.] fork.

[	101 to: 110 do: 
[:i |  Transcript nextPutAll: i  printString, '' ''.  Processor yield]. 
Transcript endEntry.] fork
]]]

Figure *TwoInterleavingProcesses* shows the output produced by the execution of the snippet.

+Two interleaving processes.>file://figures/TwoInterleavedProcesses.pdf|width=50|label=TwoInterleavingProcesses+ 

+file://figures/TwoInterleavedProcesses.pdf+ 	
	'! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:04'!
testCode
	self parse: '[[[
		Transcript crShow: ''Hi there!!''
	]]]' rule: #code.

	self assert: result = #code.! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:00'!
testCode2
	self parse: '[[[
[	1 to: 10 do: 
    [:i | Transcript nextPutAll: i  printString, '' ''. Processor yield].
Transcript endEntry.] fork.

[	101 to: 110 do: 
[:i |  Transcript nextPutAll: i  printString, '' ''.  Processor yield]. 
Transcript endEntry.] fork
]]]' rule: #code.! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:09'!
testCodeIsland
	self parse: '[[[
		Transcript crShow: ''Hi there!!''
	]]]' rule: #code.

	self assert: result = #code.! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:07'!
testFile
	self parse: self source1.

	self assert: result size = 3.
	self assert: result first = #code.
	self assert: result second = #link.
	self assert: result third = #link.! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:04'!
testLink
	self parse: '+file://whatever+' rule: #link.
	
	self assert: result = #link.! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 11:58'!
testLink2
	self parse: '+Two interleaving processes.>file://figures/TwoInterleavedProcesses.pdf|width=50|label=TwoInterleavingProcesses+' rule: #link.! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 11:59'!
testLink3
	self parse: '+file://figures/TwoInterleavedProcesses.pdf+' rule: #link.! !

!GTPillarParserTest methodsFor: 'as yet unclassified' stamp: 'JanKurs 8/20/2014 12:09'!
testLinkIsland
	self parse: '+file://whatever+' rule: #link.
	
	self assert: result = #link.! !

!FileReference methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 4/8/2014 06:54'!
gtInspectorPillarConfigurationIn: composite
	<gtInspectorPresentationOrder: 40>
	(self basename = 'pillar.conf')
		ifFalse: [ ^ self ].
	((PRSTONConfigurationInterpreter baseDirectory: self parent)
		buildFromFile: self)
			gtInspectorInputFilesIn: composite! !

!FileReference methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'AndreiChis 9/2/2014 16:47'!
gtInspectorPillarIn: composite
	<gtInspectorPresentationOrder: 40>
	(#('pier' 'pillar') includes: self extension)
		ifFalse: [ ^ self ].
	
	composite custom: (GLMRubricHighlightedTextPresentation new
		title: 'Pillar';
		editingMode: [ : rubPresentation |
			GLMHighlighterTextRubEditingMode withStylerDecorator: (
				GTPillarHighlighterTextDecorator 
					inPresentation: rubPresentation
					fileReference: self)];
		display: [ self readStreamDo: #contents ];
		act: [:rub | 
			self 
				ensureDelete; 
				writeStreamDo: [ :s | s nextPutAll: rub text asString ]] 
			icon: GLMUIThemeExtraIcons glamorousSave 
			on: $s 
			entitled: 'Save')! !

!FileReference methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 8/22/2014 08:42'!
gtInspectorPillarProjectIn: composite
	<gtInspectorPresentationOrder: 20>
	(self isDirectory not or: [
	(self files noneSatisfy: [:each | each basename = 'pillar.conf'])])
		ifTrue: [ ^ self ].
	(((PRSTONConfigurationInterpreter baseDirectory: self)
		buildFromFile: (self files detect: [:each | each basename = 'pillar.conf']))
			gtInspectorInputFilesIn: composite)
			title: 'Pillar'! !

TextAction subclass: #GTPillarFileTextLink
	instanceVariableNames: 'fileReference presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarFileTextLink methodsFor: 'evaluating' stamp: 'TudorGirba 9/1/2014 15:20'!
actOnClick: anEvent for: anObject in: paragraph editor: editor
	^ self presentation selection: fileReference! !

!GTPillarFileTextLink methodsFor: 'accessing' stamp: 'TudorGirba 9/2/2014 10:44'!
fileReference: aFileReference
	fileReference := aFileReference ! !

!GTPillarFileTextLink methodsFor: 'accessing' stamp: 'TudorGirba 9/1/2014 15:17'!
presentation
	^ presentation! !

!GTPillarFileTextLink methodsFor: 'accessing' stamp: 'TudorGirba 9/1/2014 15:17'!
presentation: anObject
	presentation := anObject! !

Object subclass: #GTHighlightingCommand
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

GTHighlightingCommand subclass: #GTHeadingHighlightingCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTHeadingHighlightingCommand methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 16:03'!
executeOn: aText inPresentation: aPresentation relativeToFileReference: aFileReference
	aText 
		addAttribute: (TextColor color: Color blue darker)
		from: self token start 
		to: self token stop! !

!GTHighlightingCommand methodsFor: 'accessing' stamp: 'TudorGirba 9/2/2014 10:14'!
executeOn: aText inPresentation: aPresentation relativeToFileReference: aFileReference
	self subclassResponsibility ! !

!GTHighlightingCommand methodsFor: 'accessing' stamp: 'TudorGirba 8/27/2014 06:43'!
token
	^ token! !

!GTHighlightingCommand methodsFor: 'accessing' stamp: 'TudorGirba 8/27/2014 06:43'!
token: anObject
	token := anObject! !

GTHighlightingCommand subclass: #GTNoteHighlightingCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTNoteHighlightingCommand methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/3/2014 16:06'!
executeOn: aText inPresentation: aPresentation relativeToFileReference: aFileReference
	aText 
		addAttribute: (TextColor color: Color red muchDarker)
		from: self token start 
		to: self token stop! !

GTHighlightingCommand subclass: #GTPillarCodeHighlightingCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarCodeHighlightingCommand methodsFor: 'as yet unclassified' stamp: 'TudorGirba 9/2/2014 11:53'!
executeOn: aText inPresentation: aPresentation relativeToFileReference: aFileReference
	| styler styledText |
	styler := SHTextStylerST80 new.
	styler classOrMetaClass: nil.
	styledText := styler styledTextFor: (aText copyFrom: self token start to: self token stop).
	aText replaceFrom: self token start to: self token stop with: styledText
"	aText 
		addAttribute: TextColor gray
		from: self token start 
		to: self token stop "! !

GTHighlightingCommand subclass: #GTPillarFileHighlightingCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarFileHighlightingCommand methodsFor: 'accessing' stamp: 'TudorGirba 9/2/2014 10:49'!
executeOn: aText inPresentation: aPresentation relativeToFileReference: aFileReference
	| attribute targetFileReference |
	targetFileReference := aFileReference parent resolveString: self token parsedValue.
	attribute := targetFileReference exists 
		ifTrue: [ GTPillarFileTextLink new
									fileReference: targetFileReference;
									presentation: aPresentation ]
		ifFalse: [ TextColor red ].
	aText 
		addAttribute: attribute
		from: self token start 
		to: self token stop.! !

GTHighlightingCommand subclass: #GTPillarLinkHighlightingCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarLinkHighlightingCommand methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2014 15:45'!
executeOn: aText inPresentation: aPresentation relativeToFileReference: aFileReference
	| attribute target |
	[target := ZnEasy get: self token parsedValue.
	attribute := target isSuccess 
		ifTrue: [ GTPillarFileTextLink new
									fileReference: target contents;
									presentation: aPresentation ]
		ifFalse: [ TextColor red ]]
	on: NameLookupFailure, ZnUnknownScheme, ZnMissingHost do: [attribute := TextColor red].
	aText 
		addAttribute: attribute
		from: self token start 
		to: self token stop.! !
